//
// Aes.cpp
//
//#include "stdafx.h"

#include <windows.h>
#include <iostream>
#include <cassert>

#include "Aes.h"


using namespace std;


namespace aes_library {


/*=====================================================================*/
//!	AES 128rbgp̌f[^쐬
/*!
	AES 128rbgp̌f[^쐬܂B16oCgf[^łB
	ASY͈ȉ̒ʂłB
	-# nbVASY SHA256 ɂ passFraise ̃_CWFXg32oCgf[^𐶐܂B
	-# _CWFXg32oCg ̋oCg{0,2,4,EEE,30}A16oCgf[^𐶐AAESf[^Ƃďo͂܂B

	@param[in]		passFraise		ÍΏۂ̕f[^
	@param[out]		aesKey			AES128rbgp16oCg
	@param[out]		errorCode		G[R[h
	@retval			true			I
	@retval			false			ُI
	@author			؉pr
	@date			2011-12-04 VK쐬
*/
/*=====================================================================*/
bool createAesKey( std::string passFraise, unsigned char (&aesKey)[AES_KEY_SIZE],  AES_ERROR_CODE &errorCode )
{
	bool	bRet = true ;

	// L[Rei[̎擾
	BOOL        bResult = TRUE ;
	HCRYPTPROV  hProv = NULL ;
	HCRYPTHASH  hHash = NULL ;


	/*========*/
	/* O */
	/*========*/
	errorCode = NORMAL ;

	/*========*/
	/*  */
	/*========*/
	while( bRet == true ){
		const ALG_ID AlgId		= CALG_SHA_256 ;
		const size_t SizeHash	= 32 ;


		// CPSnh擾
		{
			bResult = CryptAcquireContext(
						&hProv,					// nh߂܂
						NULL,					// ̃[U[CSPg܂
						MS_ENH_RSA_AES_PROV,	// ohꂽMicrosoftCSPw
						PROV_RSA_AES,			// ^Cvw
						0);						// L[Rei[ꍇ̎wł
			if ( !bResult ){
				if (!CryptAcquireContext( &hProv, NULL, MS_ENH_RSA_AES_PROV, PROV_RSA_AES, CRYPT_NEWKEYSET)){
					cerr << "CryptAcquireContext error" << endl;
					errorCode = LOGIC_ERROR ;
					bRet = false ;
					break ;
				}
			}
		}

		// nbVvZCX^Xnh
		{
			bResult = CryptCreateHash(
							hProv,				// nbVlvZCSP̃nh
							AlgId,				// nbVľvZASY
							0,					// iq܂j
							0,					//  gpA0i[jZbg
							&hHash);			//  ߂CX^X̃nh
			if (!bResult){
				cerr << "CryptCreateHash error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}
		}

		// nbVvZ
		{
			bResult = CryptHashData(
							hHash,						// nbVvZCX^X̃nh
							(BYTE*)passFraise.c_str(),  // ۂ̃pX[hw
							(DWORD)passFraise.size(),	// pX[h̃oCg
							0);							// 0 w
			if (!bResult){
				cerr << "CryptHashData error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}
		}

		// nbVlvZ & AESpf[^쐬
		{
			DWORD	dwHashSize = 0 ;
			unsigned char hashResult[SizeHash] ;

			// nbVTCYmFGdwHashSize(32)oCgȊOȂNG
			bResult = CryptGetHashParam(hHash, HP_HASHVAL, NULL, &dwHashSize, 0);
			if (!bResult){
				cerr << "CryptGetHashParam error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}

			// nbVTCY(dwHashSize)҂Ăl(SizeHash)ƈقȂꍇُ͈Ƃ
			if ( dwHashSize != SizeHash ){
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}

			// nbVl 擾
			bResult = CryptGetHashParam( hHash, HP_HASHVAL, (BYTE*)hashResult, &dwHashSize, 0 );
			if (!bResult){
				cerr << "CryptGetHashParam error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}

			// nbVlAESpf[^쐬
			// nbVʂ̋oCgAČƂ
			assert( AES_KEY_SIZE*2 <= SizeHash );
			for ( size_t i=0; i<AES_KEY_SIZE; ++i ){
				aesKey[i] = hashResult[i*2] ;
			}
		}

		/**/
		break ;
	}


	/*========*/
	/* ㏈ */
	/*========*/
	// nbV CX^X 
	if ( hHash != NULL ){
		bResult = CryptDestroyHash(hHash);
		if (!bResult){
			cerr << "CryptDestroyHash error" << endl;
			errorCode = LOGIC_ERROR ;
			bRet = false ;
		}
	}

	// CPSnh
	if ( hProv != NULL ){
		bResult = CryptReleaseContext(hProv, 0);
		if (!bResult){
			cerr << "CryptReleaseContext error" << endl;
			errorCode = LOGIC_ERROR ;
			bRet = false ;
		}
	}

	return bRet ;

}



namespace {

	/*=====================================================================*/
	//!	Í 
	/*!
		CryptAPI gpÍ̏s܂B
		ÍASYȂǂ͈ȉ̕Őݒ肵܂B
		- ASYFAES
		- F128rbg
		- [hFCBC[h
		- CjVxN^(IV)F0
		- pfBOFPKCS7 (R[hłPKCS5ƋLڂĂ܂PKCS7Ɠ`łB)
		
		@param[out]		hProv			CPSnh
		@param[out]		hKey			nh
		@param[in]		keyData			Íf[^Bf[^TCY AES_KEY_SIZE B
		@param[out]		errorCode		G[R[h
		@retval			true			I
		@retval			false			ُI
		@author			؉pr
		@date			2011-12-04 VK쐬
	*/
	/*=====================================================================*/
	bool InitializeAes( HCRYPTPROV &hProv, HCRYPTKEY &hKey, unsigned char (&keyData)[AES_KEY_SIZE], AES_ERROR_CODE &errorCode )
	{
		bool bRet = true ;

		/*========*/
		/* O */
		/*========*/
		errorCode = NORMAL ;

		/*========*/
		/*  */
		/*========*/
		while( bRet == true ){
			BOOL bResult = TRUE ;

			/* CPSnh擾iÍ j */
			{
				bResult = CryptAcquireContext(
							&hProv,					// nh߂܂
							NULL,					// ̃[U[CSPg܂
							MS_ENH_RSA_AES_PROV,	// ohꂽMicrosoftCSPw
							PROV_RSA_AES,			// ^Cvw
							0);						// L[Rei[ꍇ̎wł
				if ( !bResult ){
					if (!CryptAcquireContext( &hProv, NULL, MS_ENH_RSA_AES_PROV, PROV_RSA_AES, CRYPT_NEWKEYSET)){
						cerr << "CryptAcquireContext error" << endl;
						errorCode = LOGIC_ERROR ;
						bRet = false ;
						break ;
					}
				}
			}

			/* ÍASYA ݒ */
			{
				struct KeyBLOB{
					BLOBHEADER hdr;
					DWORD cbKeySize;
					BYTE rgbKeyData[AES_KEY_SIZE]; // 16:AES_128̃L[
				};

				KeyBLOB kb;

				kb.hdr.bType	= PLAINTEXTKEYBLOB;
				kb.hdr.bVersion = CUR_BLOB_VERSION;
				kb.hdr.reserved = 0;
				kb.hdr.aiKeyAlg = CALG_AES_128;		// AES_128
				kb.cbKeySize	= AES_KEY_SIZE;		// AES_KEY_SIZE = 16

				memcpy( kb.rgbKeyData, keyData, AES_KEY_SIZE );
				
				bResult = CryptImportKey(hProv,(BYTE*)&kb, sizeof(kb), 0, 0, &hKey); // L[쐬
				if ( !bResult ){
					errorCode = LOGIC_ERROR ;
					bRet = false ;
					break ;
				}		
			}

			/* Í[hݒ(CBC[h) */
			{
				DWORD   mode = CRYPT_MODE_CBC;

				if (!CryptSetKeyParam( hKey, KP_MODE, (BYTE*)&mode, 0 )){
					errorCode = LOGIC_ERROR ;
					bRet = false ;
					break ;
				}
			}

			/* IViCjVxN^jݒ */
			{
				BYTE    iv[AES_KEY_SIZE] ;
				
				for ( size_t i=0; i<AES_KEY_SIZE; ++i ){
					iv[i] = 0 ;
				}
				
				if ( !CryptSetKeyParam( hKey, KP_IV, iv, 0)){
					errorCode = LOGIC_ERROR ;
					bRet = false ;
					break ;
				}
			}

			/* pfBO[hݒ */
			{
				DWORD      padding_mode = PKCS5_PADDING;
				
				if (!CryptSetKeyParam( hKey, KP_PADDING, (BYTE*)&padding_mode, 0)){
					errorCode = LOGIC_ERROR ;
					bRet = false ;
					break ;
				}
			}

			/* */
			break ;
		}


		/*========*/
		/* ㏈ */
		/*========*/
		return bRet ;
	}



	/*=====================================================================*/
	//!	Í 
	/*!
		CryptAPI gpÍ̉s܂B
		
		@param[in]		hProv			CPSnhBInitializeAes Ŏgpnhw肵ĂB										
		@param[in]		hKey			nhBInitializeAes Ŏgpnhw肵ĂB
		@param[out]		errorCode		G[R[h
		@retval			true			I
		@retval			false			ُI
		@author			؉pr
		@date			2011-12-04 VK쐬
	*/
	/*=====================================================================*/
	bool DisposeAes( HCRYPTPROV &hProv, HCRYPTKEY &hKey, AES_ERROR_CODE &errorCode )
	{
		bool bRet = true ;

		/*========*/
		/* O */
		/*========*/
		errorCode = NORMAL ;

		/*========*/
		/*  */
		/*========*/
		// nh
		if ( hKey != NULL ){
			if (!CryptDestroyKey(hKey)){
				cerr << "CryptDestroyKey error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
			}
		}

		// CPSnh
		if ( hProv != NULL ){
			if (!CryptReleaseContext(hProv, 0)){
				cerr << "CryptReleaseContext error" << endl;
				errorCode = LOGIC_ERROR ;
				bRet = false ;
			}
		}

		return bRet ;
	}
}



/*=====================================================================*/
//!	f[^Í
/*!
	f[^Í܂B
	ÍASYȂǏڍׂ͊֐ InitializeAes ̐QƂĂB
	
	@param[in]		rawData			ÍΏۂ̕f[^
	@param[in]		sizeRawData		rawData ̗Lf[^TCY
	@param[in]		keyData			Íf[^Bf[^TCY AES_KEY_SIZE B
	@param[out]		cryptData		Íf[^i[̈
									{֐R[OɌĂяoŃmۂĂĂB
									KvƂf[^TCYɊւ sizeCryptData ̐QƂĂB
	@param[in]		sizeCryptData	cryptData ̗Lobt@TCYB
									ȉ̊֌W𖞑ȂꍇA{֐̓G[ɂȂ܂BG[R[h INVALID_ARGUMENT ܂B
									@code
									sizeCryptData >= ((sizeRawData+16)/16)*16 ;
									@endcode
	@param[out]		cryptDataBytes	Íf[^TCY
	@param[out]		errorCode		G[R[h
	@retval			true			I
	@retval			false			ُI
	@author			؉pr
	@date			2011-12-04 VK쐬
*/
/*=====================================================================*/
bool encryptData( unsigned char* rawData, size_t sizeRawData, unsigned char (&keyData)[AES_KEY_SIZE], unsigned char* cryptData, size_t sizeCryptData, size_t &cryptDataBytes, AES_ERROR_CODE &errorCode )
{
	bool	bRet = true ;

	// L[Rei[̎擾
	HCRYPTPROV  hProv = NULL ;
	HCRYPTKEY	hKey = NULL ;


	/*========*/
	/* O */
	/*========*/
	errorCode = NORMAL ;

	// o̓obt@TCỸ`FbN
	if ( sizeCryptData < (((sizeRawData+16)/16)*16)){
		// Íf[^o͗̈s
		cerr << "[ERROR] cryptData output memory is not enough." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}
	// cryptData NULL`FbN
	if ( cryptData == NULL ){
		cerr << "[ERROR] cryptData must be memory allocated." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}
	// rawData NULL`FbN
	if ( rawData == NULL ){
		cerr << "[ERROR] rawData must be memory allocated." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}


	/*========*/
	/*  */
	/*========*/
	while( bRet == true ){

		/*  */
		if ( !InitializeAes( hProv, hKey, keyData, errorCode ) ){
			bRet = false ;
			break ;
		}

		/* Í */
		{
			DWORD		sizeData_ = sizeRawData ;

			// f[^ cryptData փRs[BcryptData ͂Əo͂˂APIdl̂
			memcpy( cryptData, rawData, sizeRawData );

			//
			cryptDataBytes = 0 ;

			// Í
			if(!CryptEncrypt(
				    hKey,						// ̃nh
			        0,							// ÍƓɃnbVꍇɎw
			        TRUE,						// Ō̃f[^nƂɐ^
			        0,							// [w
			        cryptData,					// Íf[^̃|C^[
			        &sizeData_,					// Íf[^̃oCgf[^̊i[|C^[, Z͈Íꂽʂ̃f[^TCYi[
			        (DWORD)sizeCryptData))		// f[^obt@[̑傫
			{
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}

			// Íꂽʂ̃f[^TCYo͕ϐփRs[
			cryptDataBytes = sizeData_ ;
		}

		/**/
		break ;
	}


	/*========*/
	/* ㏈ */
	/*========*/
	if ( !DisposeAes( hProv, hKey, errorCode ) ){
		bRet = false ;
	}

	return bRet ;
}



/*=====================================================================*/
//!	f[^𕜍
/*!
	f[^𕜍܂B
	ÍASYȂǏڍׂ͊֐ InitializeAes ̐QƂĂB
	
	@param[in]		cryptData		Íf[^
	@param[in]		sizeCryptData	cryptData ̃f[^TCY
	@param[in]		keyData			Íf[^Bf[^TCY AES_KEY_SIZE B
	@param[out]		rawData			f[^i[̈
									{֐R[OɌĂяoŃmۂĂĂB
									KvƂf[^TCYɊւ sizeRawData ̐QƂĂB
	@param[in]		sizeRawstData	rawData ̗Lobt@TCYB
									ȉ̊֌W𖞑ȂꍇA{֐̓G[ɂȂ܂BG[R[h INVALID_ARGUMENT ܂B
									@code
									sizeRawData >= sizeCryptData ;
									@endcode
	@param[out]		rawDataBytes	f[^TCY
	@param[out]		errorCode		G[R[h
	@retval			true			I
	@retval			false			ُI
	@author			؉pr
	@date			2011-12-04 VK쐬
*/
/*=====================================================================*/
bool decryptData( unsigned char* cryptData, size_t sizeCryptData, unsigned char (&keyData)[AES_KEY_SIZE], unsigned char* rawData, size_t sizeRawData, size_t &rawDataBytes, AES_ERROR_CODE &errorCode )
{
	bool	bRet = true ;

	// L[Rei[̎擾
	HCRYPTPROV  hProv = NULL ;
	HCRYPTKEY	hKey = NULL ;


	/*========*/
	/* O */
	/*========*/
	errorCode = NORMAL ;

	// o̓obt@TCỸ`FbN
	if ( sizeRawData < sizeCryptData ){
		// f[^o͗̈s
		cerr << "[ERROR] rawData output memory is not enough." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}
	// cryptData NULL`FbN
	if ( cryptData == NULL ){
		cerr << "[ERROR] cryptData must be memory allocated." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}
	// rawData NULL`FbN
	if ( rawData == NULL ){
		cerr << "[ERROR] rawData must be memory allocated." << endl;
		bRet = false ;
		errorCode = INVALID_ARGUMENT ;
	}


	/*========*/
	/*  */
	/*========*/
	while( bRet == true ){

		/*  */
		if ( !InitializeAes( hProv, hKey, keyData, errorCode ) ){
			bRet = false ;
			break ;
		}

		/*  */
		{
			DWORD		sizeData_ = sizeCryptData ;

			// Íf[^ rawData փRs[BrawData ͂Əo͂˂APIdl̂
			memcpy( rawData, cryptData, sizeCryptData );
			
			//
			rawDataBytes = 0 ;

			// 
			if(!CryptDecrypt(
				    hKey,						// ̃nh
			        0,							// ƓɃnbVꍇɎw
			        TRUE,						// Ō̃f[^nƂɐ^
			        0,							// [w
			        rawData,					// f[^̃|C^[
			        &sizeData_))				// Íf[^̃oCgf[^̊i[|C^[, Z͕ꂽʂ̃f[^TCYi[
			{
				errorCode = LOGIC_ERROR ;
				bRet = false ;
				break ;
			}

			// ꂽʂ̃f[^TCYo͕ϐփRs[
			rawDataBytes = sizeData_ ;
		}

		/**/
		break ;
	}


	/*========*/
	/* ㏈ */
	/*========*/
	if ( !DisposeAes( hProv, hKey, errorCode ) ){
		bRet = false ;
	}

	return bRet ;
}


} // namespace aes_library
