// test_AES_native.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include "Aes.h"


using namespace std;
using namespace boost::property_tree;

using namespace aes_library;



int _tmain(int argc, _TCHAR* argv[])
{
	bool			bRet = true ;

	// f[^
	unsigned char	rawData[] = {00, 01, 02, 03};
	size_t			sizeRawData = sizeof(rawData)/sizeof(rawData[0]);

	// Íf[^
	unsigned char*	cryptData = NULL ;
	size_t			sizeCryptData = 0 ;				// crpyptData ̃obt@TCY
	size_t			cryptDataBytes = 0 ;			// Íꂽʂ̃f[^TCY

	// Íf[^畜ꂽf[^
	unsigned char*	rawData2 = NULL ;
	size_t			sizeRawData2 = 0 ;				// rawData2 ̃obt@TCY
	size_t			rawData2Bytes = 0 ;				// ꂽʂ̃f[^TCY

	// 
	string			strEncryptState = "";			// Í "ON" or "OFF" ; _~[AK"ON"ɂĖ{vOŝ
	string			strPassFraise = "";				// pXt[Y
	unsigned char	aesKey[AES_KEY_SIZE];			// AESZpf[^
	
	// G[R[h
	AES_ERROR_CODE	errorCode ;


	/*========*/
	/* O */
	/*========*/
	UNREFERENCED_PARAMETER(argc);			// UNREFERENCED_PARAMETER  WinNT.h Œ`Ă܂B
	UNREFERENCED_PARAMETER(argv);			// UNREFERENCED_PARAMETER  WinNT.h Œ`Ă܂B


	/*========*/
	/*  */
	/*========*/
	while(bRet) {

		/*==================================================*/
		/* configuration.xml t@CpXt[Y擾 */
		/*==================================================*/
		/*
			NOTE:
			XMLt@C̓ǂݎ boostCu(Ver. 1.47)  property_tree gpĂ܂B
			property_tree  boostCu1.41ȍ~gpł܂B
			boostCu͈ȉURL擾ĂBboostpro ɂCXg[gpyɓł܂B
			http://www.boost.org/
			http://www.boostpro.com/download/
		*/
		{
			const string filename = "configuration.xml";
			ptree pt;

			// XMLt@CJ
			try{
				read_xml( filename, pt );
			}
			catch( xml_parser_error e ){
				// filename ꍇ̗O
				cerr << "[ERROR] Cannnot open file \"" << filename << "\"" << "." << endl;
				bRet = false ;
				break ;
			}

			// pXt[Yǂݎ
			if ( boost::optional<std::string> str = pt.get_optional<std::string>("Documents.DataFormat.Encryption.<xmlattr>.PassFraise") )
			{
				strPassFraise = str.get();
				cout << "Pass fraise : \"" << strPassFraise << "\"" << endl << endl;
			}
			else {
				//  "Documents.DataFormat.Encryption.<xmlattr>.PassFraise" ꍇُ̈폈
				cerr << "[ERROR] \"Documents.DataFormat.Encryption.<xmlattr>.PassFraise\" is nothing." << std::endl;
				bRet = false ;
				break ;
			}
		}
		
		// strPassFraise 16oCǧ񐶐
		{
			AES_ERROR_CODE	errorCode = NORMAL ;

			if (!createAesKey( strPassFraise, aesKey, errorCode )){
				cerr << "[ERROR] createAesKey() is fail." << endl;
				bRet = false ;
				break ;
			}
		}

		// Encrypt
		{
			cout << "[Encrypt]" << endl;

			// Íʂۑ̈m
			// f[^TCY 1`16oCgŁA16̔{ɂȂlAo̓TCY
			sizeCryptData = ((sizeRawData + 16)/16)*16 ;
			if ( cryptData != NULL ){
				delete[] cryptData ;
			}
			cryptData = new unsigned char[sizeCryptData];
			
			if ( !encryptData( rawData, sizeRawData, aesKey, cryptData, sizeCryptData, cryptDataBytes, errorCode ) ){
				cerr << "[ERROR] encryptData() is fail." << endl;
				bRet = false ;
				break ;
			}

			// Íꂽf[^TCỸ`FbN
			assert( sizeCryptData == cryptDataBytes );
		}

		// Zʏo
		{
			cout << "Key         : ";
			for ( size_t i=0; i<AES_KEY_SIZE; ++i ){
				cout << hex << setw(2) << setfill('0') << (int)aesKey[i] << " ";
			}
			cout << endl;

			cout << "Raw data    : ";
			for ( size_t i=0; i<sizeRawData; ++i ){
				cout << hex << setw(2) << (int)rawData[i] << " ";
			}
			cout << endl;

			cout << "Crypt data  : ";
			for ( size_t i=0; i<cryptDataBytes; ++i ){
				cout << hex << setw(2) << (int)cryptData[i] << " ";
			}
			cout << endl;

			cout << endl;
		}


		// Decrypt
		{
			cout << "[Decrypt]" << endl;
			
			// ʂۑ̈m
			sizeRawData2 = cryptDataBytes ;
			if ( rawData2 != NULL ){
				delete[] rawData2 ;
			}
			rawData2 = new unsigned char[sizeRawData2];
			
			if ( !decryptData( cryptData, cryptDataBytes, aesKey, rawData2, sizeRawData2, rawData2Bytes, errorCode ) ){
				cerr << "[ERROR] encryptData() is fail." << endl;
				bRet = false ;
				break ;
			}
		}

		// Zʏo
		{
			cout << "Key         : ";
			for ( size_t i=0; i<AES_KEY_SIZE; ++i ){
				cout << hex << setw(2) << setfill('0') << (int)aesKey[i] << " ";
			}
			cout << endl;

			cout << "Crypt data  : ";
			for ( size_t i=0; i<cryptDataBytes; ++i ){
				cout << hex << setw(2) << (int)cryptData[i] << " ";
			}
			cout << endl;

			cout << "Raw data    : ";
			for ( size_t i=0; i<rawData2Bytes; ++i ){
				cout << hex << setw(2) << (int)rawData2[i] << " ";
			}
			cout << endl;

			cout << endl;
		}


		// ZʊmF
		{
			// f[^TCY `FbN
			assert( sizeRawData == rawData2Bytes );

			// f[^`FbN
			for ( size_t i=0; i<sizeRawData; ++i ){
				assert( rawData[i] == rawData2[i] );
			}
		}

		/**/
		break ;
	}


	/*========*/
	/* ㏈ */
	/*========*/
	// \[X
	if ( cryptData != NULL ){
		delete[] cryptData ;
		cryptData = NULL ;
	}
	if ( rawData2 != NULL ){
		delete[] rawData2 ;
		rawData2 = NULL ;
	}

	// ʏo
	{
		cout << "[Result] " ;
		if ( bRet ){
			cout << "OK" << endl;
		}
		else{
			cout << "!!! NG !!!" << endl;
		}
	}

	// [enter]L[҂
	{
		string str ;
		cout << "HIT [enter] KEY !! " ;
		getline( cin, str );
		
	}

	// return
	if ( bRet ){
		return EXIT_SUCCESS;
	}
	else{
		return EXIT_FAILURE;
	}
}

